package com.idea.oa.flow2.controller;

import com.github.pagehelper.PageInfo;
import com.idea.oa.flow2.model.FlowMainPush;
import com.idea.oa.flow2.service.FlowMainPushService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Date;

/**
 * Created by zt on 2023
 */
@Controller
@RequestMapping(value = "FlowMainPushController")
@Api(value="申请流程/流程推送待审核_主申请审核表")
public class FlowMainPushController extends BaseController {

    //主表
    @Autowired
    private FlowMainPushService modelService;


    @PostMapping(value = "list",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, FlowMainPush model, DateTrans dt){
        PageInfo<FlowMainPush> page= modelService.list(tablepar,model,dt);
        TableSplitResult<FlowMainPush> result=new TableSplitResult<FlowMainPush>(page.getPageNum(), page.getTotal(), page.getList());
        return  result;
    }

    @PostMapping(value = "listAll",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(FlowMainPush model, DateTrans dt){
        return  modelService.listAll(model,dt);
    }

    @PostMapping(value = "add",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(FlowMainPush record){
        record.setCreatedAt(new Date());
        int result = modelService.insert(record);
        return result(result);
    }

    @PostMapping(value = "remove/{id}",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult remove(@PathVariable("id") String id){
        int result = modelService.deleteByPrimaryKey(id);
        return result(result);
    }

    @PostMapping(value = "edit",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult editSave(FlowMainPush model){
        int result = modelService.updateByPrimaryKeySelective(model);
        return result(result);
    }

    @PostMapping(value = "getById",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public FlowMainPush getById(String id) {
        return modelService.selectByPrimaryKey(id);
    }


}
