package com.idea.paymentManagement.service;

import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.idea.buildManage.mapper.ParkRoomMapper;
import com.idea.buildManage.model.ParkRoom;
import com.idea.customerManagement.dto.ContractManageDto;
import com.idea.customerManagement.mapper.ContractManageMapper;
import com.idea.customerManagement.model.ContractManage;
import com.idea.invoice.model.InvoiceBank;
import com.idea.invoice.model.InvoiceBankExample;
import com.idea.invoice.model.InvoiceManage;
import com.idea.invoice.model.InvoiceManageExample;
import com.idea.invoice.service.InvoiceBankService;
import com.idea.invoice.service.InvoiceManageService;
import com.idea.paymentManagement.mapper.MaintenanceFundsManagementExtendMapper;
import com.idea.paymentManagement.mapper.MaintenanceFundsManagementMapper;
import com.idea.paymentManagement.mapper.PayLogMapper;
import com.idea.paymentManagement.model.MaintenanceFundsManagement;
import com.idea.paymentManagement.model.MaintenanceFundsManagementExample;
import com.idea.paymentManagement.model.PayLog;
import com.idea.paymentManagement.model.PayLogExample;
import com.rockstar.common.base.BaseService;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import com.rockstar.util.StringUtils;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Service
public class MaintenanceFundsManagementService implements BaseService<MaintenanceFundsManagement, MaintenanceFundsManagementExample> {

    @Autowired
    private MaintenanceFundsManagementMapper modelMapper;
    @Autowired
    private MaintenanceFundsManagementExtendMapper extendMapper;
    @Autowired
    private ContractManageMapper contractManageMapper;
    @Autowired
    private InvoiceBankService invoiceBankService;
    @Autowired
    private ParkRoomMapper parkRoomMapper;
    @Autowired
    private PayLogMapper payLogMapper;
    @Autowired
    private InvoiceManageService invoiceManageService;



    @Override
    public int deleteByPrimaryKey(String s) {
        return modelMapper.deleteByPrimaryKey(s);
    }

    @Override
    public int insertSelective(MaintenanceFundsManagement maintenanceFundsManagement) {
        maintenanceFundsManagement.setId(IdUtil.simpleUUID());
        return modelMapper.insertSelective(maintenanceFundsManagement);
    }

    public int insertWithoutId(MaintenanceFundsManagement maintenanceFundsManagement) {
        return modelMapper.insertSelective(maintenanceFundsManagement);
    }

    @Override
    public MaintenanceFundsManagement selectByPrimaryKey(String s) {
        return modelMapper.selectByPrimaryKey(s);
    }

    @Override
    public int updateByPrimaryKeySelective(MaintenanceFundsManagement maintenanceFundsManagement) {
        return modelMapper.updateByPrimaryKeySelective(maintenanceFundsManagement);
    }

    @Override
    public int updateByExampleSelective(MaintenanceFundsManagement maintenanceFundsManagement, MaintenanceFundsManagementExample maintenanceFundsManagementExample) {
        return modelMapper.updateByExampleSelective(maintenanceFundsManagement,maintenanceFundsManagementExample);
    }

    @Override
    public int updateByExample(MaintenanceFundsManagement maintenanceFundsManagement, MaintenanceFundsManagementExample maintenanceFundsManagementExample) {
        return modelMapper.updateByExample(maintenanceFundsManagement,maintenanceFundsManagementExample);
    }

    @Override
    public List<MaintenanceFundsManagement> selectByExample(MaintenanceFundsManagementExample maintenanceFundsManagementExample) {
        return modelMapper.selectByExample(maintenanceFundsManagementExample);
    }

    @Override
    public long countByExample(MaintenanceFundsManagementExample maintenanceFundsManagementExample) {
        return modelMapper.countByExample(maintenanceFundsManagementExample);
    }

    @Override
    public int deleteByExample(MaintenanceFundsManagementExample maintenanceFundsManagementExample) {
        return modelMapper.deleteByExample(maintenanceFundsManagementExample);
    }


    /**
     * 收款登记
     * @param model
     * @return
     */
    public int add(MaintenanceFundsManagement model){

        // 更新合同 专项维修资金收取状态
        ContractManage contractManage = contractManageMapper.selectByPrimaryKey(model.getContractId());
        BigDecimal payMoney = model.getPayMoney();
        BigDecimal maintenanceTotalPrice = contractManage.getMaintenanceTotalPrice();
        if(payMoney.doubleValue() >= maintenanceTotalPrice.doubleValue()){
            // 已收款
            contractManage.setFundCollectionStatus(2);
        }else {
            // 部分收款
            contractManage.setFundCollectionStatus(4);
        }

        contractManageMapper.updateByPrimaryKeySelective(contractManage);

        String id = IdUtil.simpleUUID();
        model.setId(id);
        model.setHouseId(contractManage.getHouseId());
        model.setCustomerManagementId(contractManage.getCustomerManagementId());
        model.setCreatedId(ShiroUtils.getUserId());
        model.setCreatedAt(new Date());
        int result = insertWithoutId(model);

        // 新增一条定金收款记录
        PayLog payLog = new PayLog();
        payLog.setId(IdUtil.simpleUUID());
        payLog.setHouseId(contractManage.getHouseId());
        payLog.setContractId(model.getContractId());
        payLog.setCustomerManagementId(contractManage.getCustomerManagementId());
        payLog.setBusinessId(id);
        // 收款类型 专项维修资金
        payLog.setPayType(2);
        // 款项内容 专项维修资金
        payLog.setContentType(4);
        payLog.setPayMoney(model.getPayMoney());
        payLog.setPayTime(new Date());
        payLog.setPaymentMethod(model.getPaymentMethod());
        payLog.setStatus(0);
        payLog.setCreatedAt(new Date());
        payLog.setCreatedBy(ShiroUtils.getUserId());
        payLog.setBankName(model.getBankName());
        payLog.setBankBranchName(model.getBankBranchName());
        payLog.setBankNumber(model.getBankNumber());
        payLogMapper.insertSelective(payLog);

        // 查询合同的房款收款情况
        Integer collectionStatus = contractManage.getFundCollectionStatus();
        // 完全收款
        if(collectionStatus == 2){
            // 查询该合同是否已生成 正式发票 且类型是专项维修资金
            InvoiceManageExample invoiceManageExample = new InvoiceManageExample();
            invoiceManageExample.createCriteria().andTypeEqualTo("2")
                    .andContractIdEqualTo(model.getContractId())
                    .andPaymentTypeEqualTo("2");
            List<InvoiceManage> invoiceManages = invoiceManageService.selectByExample(invoiceManageExample);
            if(CollectionUtils.isEmpty(invoiceManages)){
                // 生成一条待推送的开票信息
                InvoiceManage invoiceManage = invoiceManageService.getInfoByContract(model.getContractId(),
                        "*不动产*",2);
                // 正式发票
                invoiceManage.setType("2");
                // 专项维修资金
                invoiceManage.setPaymentType("2");
                invoiceManage.setSendStatus("0");
                invoiceManage.setInvoiceStatus("0");
                invoiceManage.setInvoiceTax(null);
                invoiceManage.setRemark(null);
                invoiceManage.setCreateUser(ShiroUtils.getUserId());
                invoiceManage.setCreateTime(new Date());
                invoiceManageService.insertSelective(invoiceManage);
            }
        }



        return result;
    }


    /**
     * 收款登记
     * @param model
     * @return
     */
    @Transactional
    public int edit(MaintenanceFundsManagement model){

        // 更新合同 专项维修资金收取状态
        ContractManage contractManage = contractManageMapper.selectByPrimaryKey(model.getContractId());
        BigDecimal payMoney = model.getPayMoney();
        BigDecimal maintenanceTotalPrice = contractManage.getMaintenanceTotalPrice();
        if(payMoney.doubleValue() >= maintenanceTotalPrice.doubleValue()){
            // 已收款
            contractManage.setFundCollectionStatus(2);
        }else {
            // 部分收款
            contractManage.setFundCollectionStatus(4);
        }

        contractManageMapper.updateByPrimaryKeySelective(contractManage);

        model.setHouseId(contractManage.getHouseId());
        model.setCustomerManagementId(contractManage.getCustomerManagementId());
        model.setCreatedId(ShiroUtils.getUserId());
        model.setCreatedAt(new Date());
        int result = updateByPrimaryKeySelective(model);

        // 更新对应的收款记录
        PayLogExample payLogExample = new PayLogExample();
        payLogExample.createCriteria().andBusinessIdEqualTo(model.getId()).andPayTypeEqualTo(2);
        List<PayLog> payLogs = payLogMapper.selectByExample(payLogExample);
        if(CollectionUtils.isNotEmpty(payLogs) && payLogs.size() == 1){
            PayLog payLog = payLogs.get(0);
            payLog.setPayMoney(model.getPayMoney());
            payLog.setUpdatedAt(new Date());
            payLog.setUpdatedBy(ShiroUtils.getUserId());
            payLogMapper.updateByPrimaryKeySelective(payLog);
        }

        // 更新对应的 未推送 未开票 专项维修资金 正式发票
        InvoiceManageExample invoiceManageExample = new InvoiceManageExample();
        invoiceManageExample.createCriteria().andTypeEqualTo("2")
                .andContractIdEqualTo(model.getContractId())
                .andPaymentTypeEqualTo("2")
                .andSendStatusEqualTo("0");
        List<InvoiceManage> invoiceManages = invoiceManageService.selectByExample(invoiceManageExample);
        if(CollectionUtils.isEmpty(invoiceManages) && invoiceManages.size() == 1){
            InvoiceManage invoiceManage = invoiceManages.get(0);
            invoiceManage.setInvoiceAmount(payMoney);
            invoiceManageService.updateByPrimaryKeySelective(invoiceManage);
        }

        return result;
    }


    public PageInfo<ContractManageDto> listByModel(Tablepar tablepar, ContractManageDto model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<ContractManageDto> list = extendMapper.listByModel(model);
        PageInfo<ContractManageDto> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

    /**
     * 查询对应的银行
     * @param contractId
     * @return
     */
    public JSONObject getBankByFloor(String contractId) {
        JSONObject jsonObject = new JSONObject();
        String result = "";
        // 1-房款，2-专项维修资金
        InvoiceBankExample example = new InvoiceBankExample();
        example.createCriteria().andSuitCostTypeLike("%" + "专项维修资金" + "%");
        List<InvoiceBank> bankList = invoiceBankService.selectByExample(example);
        ContractManage contractManage = contractManageMapper.selectByPrimaryKey(contractId);
        ParkRoom parkRoom = parkRoomMapper.selectByPrimaryKey(contractManage.getHouseId());
        String discId = parkRoom.getDiscId();
        for (InvoiceBank invoiceBank : bankList) {
            if (StringUtils.isNotEmpty(invoiceBank.getSuitFloor())) {
                String[] floors = invoiceBank.getSuitFloor().split(",");
                for (String floor : floors) {
                    if (discId.equals(floor)) {
                        result = invoiceBank.getBankName() + invoiceBank.getBankBranchName() + invoiceBank.getBankNumber();
                        jsonObject.put("bankName", invoiceBank.getBankName());
                        jsonObject.put("bankBranchName", invoiceBank.getBankBranchName());
                        jsonObject.put("bankNumber", invoiceBank.getBankNumber());
                        jsonObject.put("bankFullName", result);
                        break;
                    }
                }
            }
        }
        return jsonObject;
    }

    public MaintenanceFundsManagement getById(String id){
        return modelMapper.selectByPrimaryKey(id);
    }







}
